"use strict";
var __assign = (this && this.__assign) || function () {
    __assign = Object.assign || function(t) {
        for (var s, i = 1, n = arguments.length; i < n; i++) {
            s = arguments[i];
            for (var p in s) if (Object.prototype.hasOwnProperty.call(s, p))
                t[p] = s[p];
        }
        return t;
    };
    return __assign.apply(this, arguments);
};
Object.defineProperty(exports, "__esModule", { value: true });
var jsx_runtime_1 = require("@emotion/react/jsx-runtime");
var Styled = require("./style");
var react_1 = require("react");
var date_1 = require("../../../types/date");
var string_1 = require("../../../utilities/string");
var useClickOutside_1 = require("../../../hooks/useClickOutside");
var useCursor_1 = require("../../../hooks/useCursor");
var ArrowButton_1 = require("../../common/ArrowButton");
var props_1 = require("../../../utilities/props");
var useActive_1 = require("../../../hooks/useActive");
var Month_1 = require("./Month");
var Weekdays_1 = require("./Weekdays");
var Days_1 = require("./Days");
var event_1 = require("../../../utilities/event");
var DatePicker = (0, react_1.forwardRef)(function (props, forwardedRef) {
    var weekdays = props.weekdays, _a = props.mondayFirst, mondayFirst = _a === void 0 ? true : _a, _b = props.weekendColor, weekendColor = _b === void 0 ? true : _b, value = props.value, onChange = props.onChange, _c = props.onClick, onClick = _c === void 0 ? function () { } : _c, _d = props.onFocus, onFocus = _d === void 0 ? function () { } : _d, _e = props.onSearch, onSearch = _e === void 0 ? function () { } : _e, listContainerStyle = props.listContainerStyle, listStyle = props.listStyle, itemStyle = props.itemStyle;
    var _f = (0, useActive_1.default)(), active = _f.active, setActive = _f.setActive, handleActive = _f.handleActive;
    var _g = (0, react_1.useState)(date_1.Date.string(value)), date = _g[0], setDate = _g[1];
    var containerRef = (0, react_1.useRef)(null);
    var inputRef = (0, react_1.useRef)(null);
    var setCursor = (0, useCursor_1.default)(inputRef, date).setCursor;
    (0, useClickOutside_1.default)(containerRef, setActive);
    /**
     * Click handler
     */
    var handleClick = (0, react_1.useCallback)(function (e, item) {
        onClick(e);
        setDate(item);
        handleDispatchChange(item.getString());
        setActive(false);
    }, []);
    /**
     * Change Handler
     */
    var handleChange = (0, react_1.useCallback)(function (e) {
        var event = e.nativeEvent;
        var target = e.target;
        var cursor = target === null || target === void 0 ? void 0 : target.selectionStart;
        var data = event.data;
        if (!cursor || !data)
            return;
        // only numbers are allowed
        if (isNaN(+data))
            return;
        // cursor positioned char is dash, replaced
        if (target.value.charAt(cursor) === "-") {
            target.value = (0, string_1.replaceAt)(target.value, cursor - 1, "");
            target.value = (0, string_1.replaceAt)(target.value, cursor, data);
            setCursor(cursor + 1);
        }
        else {
            target.value = (0, string_1.replaceAt)(target.value, cursor, "");
            setCursor(cursor);
        }
        setDate(date_1.Date.string(target.value));
        onSearch(e);
    }, []);
    /**
     * Focus handler
     */
    var handleFocus = (0, react_1.useCallback)(function (e) {
        setActive(true);
        onFocus(e);
    }, []);
    /**
     * Dispatch change
     */
    var handleDispatchChange = (0, react_1.useCallback)(function (value) {
        (0, event_1.dispatchChange)(containerRef, value);
    }, []);
    var style = __assign(__assign({}, (0, props_1.getSizeProps)(props)), props.style);
    return ((0, jsx_runtime_1.jsxs)(Styled.Container, __assign({ ref: containerRef, active: active, style: style }, { children: [(0, jsx_runtime_1.jsx)("input", { ref: forwardedRef, value: value, onChange: onChange, readOnly: true, hidden: true }), (0, jsx_runtime_1.jsx)(Styled.Input, { ref: inputRef, value: date.getString(), onChange: handleChange, onFocus: handleFocus }), (0, jsx_runtime_1.jsx)(ArrowButton_1.default, { onClick: handleActive, direction: active ? "Up" : "Down" }), (0, jsx_runtime_1.jsxs)(Styled.ListContainer, __assign({ active: active, style: listContainerStyle }, { children: [(0, jsx_runtime_1.jsx)(Month_1.default, { date: date, setDate: setDate }), (0, jsx_runtime_1.jsx)(Weekdays_1.default, { weekdays: weekdays, mondayFirst: mondayFirst, weekendColor: weekendColor }), (0, jsx_runtime_1.jsx)(Days_1.default, { calendar: (0, date_1.getCalendarDate)({ date: date, mondayFirst: mondayFirst }), date: date, onClick: handleClick, listStyle: listStyle, itemStyle: itemStyle })] }))] })));
});
exports.default = DatePicker;
