var __assign = (this && this.__assign) || function () {
    __assign = Object.assign || function(t) {
        for (var s, i = 1, n = arguments.length; i < n; i++) {
            s = arguments[i];
            for (var p in s) if (Object.prototype.hasOwnProperty.call(s, p))
                t[p] = s[p];
        }
        return t;
    };
    return __assign.apply(this, arguments);
};
import { jsx as _jsx, jsxs as _jsxs } from "@emotion/react/jsx-runtime";
import { forwardRef, useCallback, useEffect, useRef, useState, } from "react";
import useClickOutside from "../../../hooks/useClickOutside";
import ArrowButton from "../../../components/common/ArrowButton";
import { getSizeProps } from "../../../utilities/props";
import useActive from "../../../hooks/useActive";
import _ from "lodash";
import * as Styled from "./style";
import { dispatchChange } from "../../../utilities/event";
import useSetScrollPosition from "../../../hooks/useSetScrollPosition";
var Select = forwardRef(function (props, forwardedRef) {
    var _a, _b, _c;
    var _d = props.searchable, searchable = _d === void 0 ? false : _d, _e = props.showItemCount, showItemCount = _e === void 0 ? 8 : _e, children = props.children, value = props.value, placeholder = props.placeholder, onChange = props.onChange, _f = props.onFocus, onFocus = _f === void 0 ? function () { } : _f, _g = props.onSearch, onSearch = _g === void 0 ? function () { } : _g, listStyle = props.listStyle, itemStyle = props.itemStyle;
    var childrens = _.isArray(children) ? children : [children];
    var _h = useActive(), active = _h.active, setActive = _h.setActive, handleActive = _h.handleActive;
    var _j = useState(""), search = _j[0], setSearch = _j[1];
    var _k = useState(childrens), result = _k[0], setResult = _k[1];
    var containerRef = useRef(null);
    var listRef = useRef(null);
    var itemRef = useRef(null);
    var itemIndex = result.findIndex(function (item) { return item.props.value === value; });
    var itemHeight = (_b = (_a = itemRef.current) === null || _a === void 0 ? void 0 : _a.clientHeight) !== null && _b !== void 0 ? _b : 0;
    useClickOutside(containerRef, setActive);
    useSetScrollPosition(listRef, itemIndex * itemHeight, active);
    useEffect(function () {
        if (active) {
            setResult(childrens);
        }
    }, [active]);
    var handleKeyDown = useCallback(function (e) {
        switch (e.nativeEvent.key) {
            case "Enter":
                var find = childrens.find(function (item) { return (item === null || item === void 0 ? void 0 : item.props.children) === search; });
                find && handleDispatchChange(find.props);
                break;
            case "Escape":
                setActive(false);
                break;
            default:
                var filter = childrens.filter(function (item) {
                    return item === null || item === void 0 ? void 0 : item.props.children.includes(search);
                });
                setResult(filter);
                setActive(true);
        }
    }, [search]);
    var handleSearch = useCallback(function (e) {
        setSearch(e.target.value);
        onSearch(e);
    }, []);
    var handleFocus = useCallback(function (e) {
        setActive(true);
        onFocus(e);
    }, []);
    var handleDispatchChange = useCallback(function (props) {
        dispatchChange(containerRef, props.value);
        setSearch(props.children);
        setActive(false);
    }, []);
    var style = __assign(__assign({}, getSizeProps(props)), props.style);
    return (_jsxs(Styled.Container, __assign({ ref: containerRef, active: active, style: style }, { children: [_jsx("input", { ref: forwardedRef, value: value, onChange: onChange, readOnly: true, hidden: true }), _jsx(Styled.Input, { value: searchable ? search : value, placeholder: placeholder, onChange: handleSearch, onFocus: handleFocus, onKeyUp: function (e) { return handleKeyDown(e); }, readOnly: searchable ? false : true }), _jsx(ArrowButton, { onClick: handleActive, direction: active ? "Up" : "Down" }), _jsx(Styled.List, __assign({ ref: listRef, active: active, itemHeight: (_c = itemStyle === null || itemStyle === void 0 ? void 0 : itemStyle.height) !== null && _c !== void 0 ? _c : "35px", showItemCount: Math.min(childrens.length, showItemCount), style: listStyle }, { children: result.map(function (item) { return (_jsx(Styled.Item, __assign({ ref: itemRef, active: item.props.value === value, onClick: function () { return handleDispatchChange(item.props); }, style: itemStyle }, { children: item.props.children }), item.props.value)); }) }))] })));
});
export default Select;
